chiark / gitweb /
More GIT config things.
[profile] / setup
CommitLineData
65ff0e8c 1#! /bin/bash
f617db13
MW
2
3set -e
4
5umask 002
6
4aa875e9 7sub=
f617db13
MW
8mkdir -p $HOME$sub
9
0633739b 10: ${REPO=http://guvnor.distorted.org.uk/ftp/pub/mdw/profile}
f617db13
MW
11
12export PATH=/usr/local/bin:$HOME$sub/bin:/usr/bin:/usr/ccs/bin:/bin
13
14### Sort out command line
15xstuff= false=
16while [ $# -gt 0 ]; do
17 case "$1" in
18 -x) xstuff=t;;
19 -n) false=false;;
20 --) shift; break;;
21 -*) echo >&2 "$0: bad option"; exit 1;;
22 *) break;;
23 esac
24 shift
25done
26
27### Find out where I am
28here=$(pwd)
f617db13
MW
29
30### Suss out how to print things
31out=$(echo -n "foo"; echo "bar")
32if [ "$out" = "foobar" ]; then
33 echon="echo -n"
34 echoc=""
35else
36 echon="echo"
37 echoc='\c'
38fi
39
40### Create the necessary directories
41echo "Creating directories..."
42for i in bin lib/emacs src; do
43 $echon " $i:$echoc"
44 if [ -d $HOME$sub/$i ]; then
45 echo " already exists."
46 else
47 mkdir -p $HOME$sub/$i
48 echo " done."
49 fi
50done
51echo " all done."
52
53### Find out how to fetch things over the net
54$echon "Finding URL fetcher:$echoc"
55if curl >/dev/null 2>&1 --version || [ $? -eq 2 ]; then
56 GETURL="curl -fs -o"
57 echo " curl."
58elif wget >/dev/null 2>&1 --version; then
59 GETURL="wget -q -O"
60 echo " wget."
61else
62 echo " failed!"
63 echo >&2 "$0: failed to find URL fetcher"
64 exit 1
65fi
66
67### Install necessary things
68echo "Installing useful scripts..."
69
af58d83c 70scripts="
370d4c8d 71 lesspipe.sh start-ssh-agent svnwrap movemail-hack"
af58d83c
MW
72[ "$xstuff" ] && scripts="$scripts
73 xrun"
74for script in $scripts; do
f617db13
MW
75 $echon " $script:$echoc"
76 found=
77 for p in /bin /usr/bin /usr/local/bin $(echo $PATH | tr : ' '); do
78 if $false [ -x $p/$script ]; then
79 found=t
80 break
81 fi
82 done
83 if [ "$found" ]; then
84 echo " already installed."
85 else
86 $echon " downloading$echoc"
87 $GETURL $HOME$sub/bin/$script $REPO/$script
88 chmod +x $HOME$sub/bin/$script
89 echo " done."
90 fi
91done
92
93echo " all done."
94
95### Install some more complicated programs
96echo "Installing packages..."
97systems="
98 mLib:2.0.3:mLib-config
99 chkpath:1.1.0:tmpdir
100"
101[ "$xstuff" ] && systems="$systems
102 mgLib:1.1.0:mgLib-config
103 xtoys:1.3.0:xscsize
104"
105for system in $systems; do
106 set -- $(echo $system | tr : ' ')
107 sys=$1 ver=$2 prog=$3
108 $echon " $sys:$echoc"
109 if $false $prog >/dev/null 2>&1 --version; then
110 echo " already installed."
111 else
112 ( set -e
113 $echon " downloading$echoc"
114 cd $HOME$sub/src
115 rm -rf $sys-$ver.tar.gz $sys-$ver
116 $GETURL $sys-$ver.tar.gz $REPO/$sys-$ver.tar.gz
117 $echon " unpacking$echoc"
118 gzip -cd $sys-$ver.tar.gz | tar xf -
119 $echon " configuring$echoc"
120 cd $sys-$ver
121 mkdir build
122 cd build
123 ../configure --prefix=$HOME$sub >>buildlog 2>&1
124 $echon " building$echoc"
125 make >>buildlog 2>&1
126 $echon " installing$echoc"
127 make install >>buildlog 2>&1
128 echo " done."
129 )
130 fi
131done
132echo " all done."
133
f141fe0f
MW
134### Install global configuration
135echo -n "Installing dotfile configuration:"
136if [ -f $HOME$sub/.mdw.conf ]; then
137 echo " already installed."
138else
139 cp mdw.conf $HOME$sub/.mdw.conf
140 echo " done."
141fi
142
f617db13
MW
143### Symlink the various dotfiles into place
144dotfiles="
be7dba95 145 bash_profile bash_logout bashrc inputrc bash_completion
f617db13 146 emacs emacs-calc
a124320a 147 vm mailrc signature
5d2b7dab 148 gitconfig cgrc stgitrc tigrc
ccaac00b
MW
149 lisp-init.lisp:.cmucl-init.lisp
150 lisp-init.lisp:.sbclrc
151 lisp-init.lisp:.clisprc.lisp
f6335a0c 152 lisp-init.lisp:.eclrc
2425eca9 153 dircolors colordiffrc screenrc cvsrc indent.pro"
739bccbf 154[ "$xstuff" ] && dotfiles="$dotfiles
eae29a8c 155 xinitrc xsession Xdefaults vncrc vncsession
739bccbf
MW
156 eterm-theme.cfg:.Eterm/themes/Eterm/theme.cfg
157 e-keybindings.cfg:.enlightenment/keybindings.cfg
eae29a8c 158 evnc-keybindings.cfg:.enlightenment-vnc/keybindings.cfg
739bccbf 159 jue-peek.jpg:.enlightenment/backgrounds/jue-peek.jpg"
f617db13
MW
160mkdir -p $HOME/test
161echo "Installing dotfiles..."
162for d in $dotfiles; do
739bccbf
MW
163 target=.$d
164 case $d in
165 *:*) target=${d#*:} d=${d%%:*};;
166 esac
167 ft=$HOME$sub/$target
168 dir=${ft%/*}
169 mkdir -p $dir
170 ln -s $here/$d $ft.new
171 mv $ft.new $ft
172 echo " $target"
f617db13
MW
173done
174echo " all done."
175
176### Set up the Emacs config
65ff0e8c
MW
177$echon "Finding a suitable emacs:$echoc"
178emacs=no
179for i in emacs21 emacs; do
180 if type -p >/dev/null $i; then
181 emacs=$i
182 break
183 fi
184done
185if [ $emacs = no ]; then
186 echo " failed."
187 emacs=:
188else
189 echo " $emacs."
190fi
191
f617db13 192echo "Installing Emacs packages..."
400223a1
MW
193emacspkg="
194 make-regexp
195 git vc-git
196 quilt"
197for elib in $emacspkg; do
f617db13 198 $echon " $elib:$echoc"
65ff0e8c 199 if $false $emacs >/dev/null 2>&1 --no-site-file --batch --eval '
20eb0692
MW
200 (progn
201 (setq load-path (nconc load-path (list "~/lib/emacs")))
202 (kill-emacs (condition-case nil
203 (progn (load-library "'"$elib"'") 0)
204 (error 1))))'; then
f617db13
MW
205 echo " already installed."
206 else
207 $echon " downloading$echoc"
20eb0692 208 $GETURL $HOME$sub/lib/emacs/$elib.el $REPO/$elib.el
f617db13
MW
209 $echon " compiling$echoc"
210 (cd $HOME$sub/lib/emacs;
65ff0e8c 211 $emacs >/dev/null 2>&1 --no-site-file --batch \
20eb0692 212 --eval '(byte-compile-file "'"$elib.el"'")')
f617db13
MW
213 echo " done."
214 fi
215done
216echo " all done."
217
218$echon "Setting up Emacs configuration:$echoc"
219$echon " linking$echoc"
220for link in dot-emacs.el:dot-emacs.el emacs-Makefile:Makefile; do
221 set -- $(echo $link | tr : ' ')
222 from=$1 to=$2
739bccbf
MW
223 ln -s $here/$from $HOME$sub/lib/emacs/$to.new
224 mv $HOME$sub/lib/emacs/$to.new $HOME$sub/lib/emacs/$to
f617db13
MW
225done
226$echon " compiling$echoc"
65ff0e8c 227make >/dev/null 2>&1 -C $HOME$sub/lib/emacs EMACS=$emacs
f617db13 228echo " done."